﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class spheremove : MonoBehaviour
{
    int objno = 1;
    rtcmixmain RTcmix;
    private bool did_start = false;

    float car;
    float mod;

    float yval;
    float xval;
    public float updownspeed;
    public float rightleftspeed;

    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        car = 300.0f;
        mod = 400.0f;

        // set up the PField connections and start the note
        String score = "car = makeconnection(\"inlet\", 1, 300) " +
            "mod = makeconnection(\"inlet\", 2, 400) " +
            "sine = maketable(\"wave\", 1000, \"sine\") " +
            "FMINST(0, 999, 10000, car, mod, 5, 5, 0.5, sine, 1) ";
        RTcmix.SendScore(score, objno);

        did_start = true;

        xval = 0.0f;
        yval = 2.0f;
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKey("]"))
        {
            yval = yval + updownspeed;
            car = car + 10.0f;
        }
        if (Input.GetKey("["))
        {p
            yval = yval - updownspeed;
            car = car - 10.0f;
        }
        if (Input.GetKey("p"))
        {
            xval = xval + rightleftspeed;
            mod = mod + 10.0f;
        }
        if (Input.GetKey("o"))
        {
            xval = xval - rightleftspeed;
            mod = mod - 10.0f;
        }
        // and this sends the car and mod values to the FMINST
        RTcmix.setpfieldRTcmix(1, car, objno);
        RTcmix.setpfieldRTcmix(2, mod, objno);

        transform.position = new Vector3(xval, yval, 0.0f);
    }

    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0);
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
